library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
--use IEEE.STD_LOGIC_ARITH.ALL;
--use IEEE.STD_LOGIC_UNSIGNED.ALL;
use IEEE.NUMERIC_STD.ALL;

entity signed_integ is
   generic(
    data_width: integer := 8;
    intern_data_width: integer := 24;
    out_width: integer := 10
    );
 
port(
      clk_i              :  in  std_logic;
      rst_i              :  in  std_logic;
      ramp_i			 :  in  std_logic;
      zero_i			 :  in  std_logic;
      data_i          	 :  in  std_logic_vector(data_width-1 downto 0);
      zeroref_i			 :  in  std_logic_vector(data_width-1 downto 0);
      data_o        	 :  out std_logic_vector(out_width-1 downto 0);
      data_o_stb		 :  out std_logic
  );
end signed_integ;

architecture Behavioral of signed_integ is

signal old_data_int : signed (intern_data_width-1 downto 0);
signal delta 		: signed (intern_data_width-1 downto 0);
begin
	integ: process(clk_i,zero_i)    
	begin
	if zero_i = '1' then
		old_data_int <= (others => '0');
		delta <= (others => '0');
	elsif rising_edge(clk_i) then
		if ramp_i = '1' then	
			old_data_int <= old_data_int + signed(zeroref_i)-signed(data_i);
		end if;
   end if;
	data_o 		<= std_logic_vector(old_data_int(18 downto 9)+old_data_int(19 downto 10));
	data_o_stb 	<= not clk_i;
	
end process integ;
end Behavioral;

