library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.NUMERIC_STD.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity SPRITE_PWM is
    Port ( clk      	: in  STD_LOGIC;
           pwmvalue 	: in  STD_LOGIC_VECTOR (7 downto 0);
           pwm_stb  	: in std_logic;
           pwmout_h   	: out STD_LOGIC := '0';
           pwmout_l   	: out STD_LOGIC := '0');
end SPRITE_PWM;


architecture Behavioral of SPRITE_PWM is

signal cnt_h : integer range 0 to 15 := 0;
signal cnt_l : integer range 0 to 15 := 0;
signal pwmvalue_h : std_logic_vector (3 downto 0);
signal pwmvalue_l : std_logic_vector (3 downto 0);

begin
   
	load_cnt : process (clk)
    begin
        if rising_edge(clk) then
			if pwm_stb = '1' then
				pwmvalue_h(3) <= pwmvalue(7);
				pwmvalue_h(2) <= not pwmvalue(6);
				pwmvalue_h(1) <= not pwmvalue(5);
				pwmvalue_h(0) <= not pwmvalue(4);
				pwmvalue_l(3) <= not pwmvalue(3);
				pwmvalue_l(2) <= not pwmvalue(2);
				pwmvalue_l(1) <= not pwmvalue(1);
				pwmvalue_l(0) <= not pwmvalue(0);
			end if;
		end if;
	end process;

   my_cnth : process
   begin
      wait until rising_edge(clk);      
		if (cnt_h<15) then cnt_h <= cnt_h+1;
		else               cnt_h <= 0;
      end if;      
  end process;
  
   my_cntl : process
   begin
      wait until rising_edge(clk);       
		if (cnt_l<15) then cnt_l <= cnt_l+1;
		else               cnt_l <= 0;
      end if;      
  end process;
   
   pwmout_h <= '0' when (cnt_h>=to_integer(unsigned(pwmvalue_h))) else '1';
   pwmout_l <= '0' when (cnt_l>=to_integer(unsigned(pwmvalue_l))) else '1'; 
end Behavioral;